package com.gic.auth.service.outer.impl;

import com.gic.api.base.commons.Page;
import com.gic.api.base.commons.ServiceResponse;
import com.gic.auth.dto.ResourceDTO;
import com.gic.auth.entity.TabSysResource;
import com.gic.auth.service.ResourceApiService;
import com.gic.auth.service.ResourceService;
import com.gic.commons.util.EntityUtil;
import com.gic.commons.util.PageHelperUtils;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 *
 * @Description:
 * @author zhiwj
 * @date 2019/8/28 18:28
 */
@Service("resourceApiService")
public class ResourceApiServiceImpl implements ResourceApiService {

    private Logger logger = LogManager.getLogger(ResourceApiServiceImpl.class);

    @Autowired
    private ResourceService resourceService;

    @Override
    public ServiceResponse<Integer> saveOrUpdateResource(ResourceDTO resourceDTO) {
        if (resourceDTO.getResourceId() == null) {
            // save
            resourceService.save(resourceDTO);
        } else {
            // update
            resourceService.update(resourceDTO);
        }
        return ServiceResponse.success();
    }

    @Override
    public ServiceResponse<Integer> delResource(Integer resourceId) {
        Integer line = resourceService.delResource(resourceId);
        return ServiceResponse.success(line);
    }

    @Override
    public ServiceResponse<Page<ResourceDTO>> listResource(ResourceDTO resourceDTO, Integer pageNum, Integer pageSize) {
        com.github.pagehelper.Page<TabSysResource> page = resourceService.listResource(resourceDTO, pageNum, pageSize);
        Page<ResourceDTO> resultPage = PageHelperUtils.changePageHelperToCurrentPage(page, ResourceDTO.class);
        return ServiceResponse.success(resultPage);
    }

    @Override
    public ServiceResponse<ResourceDTO> getResource(Integer resourceId) {
        TabSysResource resource = resourceService.getResource(resourceId);
        ResourceDTO resourceDTO = EntityUtil.changeEntityByOrika(ResourceDTO.class, resource);
        return ServiceResponse.success(resourceDTO);
    }
}
